import * as i0 from '@angular/core';
import { Directive, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

Date.equal = (date1, date2) => {
    if (!Date.isDate(date1) && !Date.isDate(date2)) {
        return true;
    }
    if (!Date.isDate(date1) || !Date.isDate(date2)) {
        return false;
    }
    return new Date(date1).getTime() === new Date(date2).getTime();
};
Date.parseFrom = (value, format) => {
    if (!value) {
        return null;
    }
    if (!format) {
        return null;
    }
    value = value.toString();
    const dmy = format.indexOf('dd') > -1 &&
        format.indexOf('MM') > -1 &&
        format.indexOf('yyyy') > -1;
    const hms = format.indexOf('HH') > -1 ||
        format.indexOf('mm') > -1 ||
        format.indexOf('ss') > -1;
    let strDate = '';
    if (dmy) {
        const dd = value.substr(format.indexOf('dd'), 'dd'.length);
        const MM = value.substr(format.indexOf('MM'), 'MM'.length);
        const yyyy = value.substr(format.indexOf('yyyy'), 'yyyy'.length);
        if (+yyyy > 0 && +MM > 0 && +dd > 0) {
            strDate += `${MM}/${dd}/${yyyy}`;
        }
        else {
            return null;
        }
    }
    else {
        const today = new Date();
        const yyyy = today.getFullYear().toString();
        const MM = (today.getMonth() + 1).toString().padStart(2, '0');
        const dd = today.getDate().toString().padStart(2, '0');
        strDate += `${MM}/${dd}/${yyyy}`;
    }
    if (hms) {
        const HH = format.indexOf('HH') > -1
            ? value.substr(format.indexOf('HH'), 'HH'.length)
            : '00';
        const mm = format.indexOf('mm') > -1
            ? value.substr(format.indexOf('mm'), 'mm'.length)
            : '00';
        const ss = format.indexOf('ss') > -1
            ? value.substr(format.indexOf('ss'), 'ss'.length)
            : '00';
        strDate += ` ${HH || '00'}:${mm || '00'}:${ss || '00'}`;
    }
    if (!Date.isDate(strDate)) {
        return null;
    }
    return new Date(strDate);
};
Date.isDate = (value) => {
    if (!value) {
        return false;
    }
    const date = new Date(value);
    return !isNaN(date.getTime());
};
Date.toFormat = (value, format) => {
    if (!Date.isDate(value)) {
        return '';
    }
    const date = new Date(value);
    return date.toFormat(format);
};
Date.addMiliseconds = (value, miliseconds) => {
    if (!Date.isDate(value)) {
        return null;
    }
    const date = new Date(value);
    return date.addMiliseconds(miliseconds);
};
Date.addHours = (value, hours) => {
    if (!Date.isDate(value)) {
        return null;
    }
    const date = new Date(value);
    return date.addHours(hours);
};
Date.addDays = (value, days) => {
    if (!Date.isDate(value)) {
        return null;
    }
    const date = new Date(value);
    return date.addDays(days);
};
Date.addMonths = (value, months) => {
    if (!Date.isDate(value)) {
        return null;
    }
    const date = new Date(value);
    return date.addMonths(months);
};
Date.begin = (value) => {
    if (!Date.isDate(value)) {
        return null;
    }
    return new Date(Date.toFormat(value, 'MM/dd/yyyy'));
};
Date.end = (value) => {
    if (!Date.isDate(value)) {
        return null;
    }
    return new Date(value).addDays(1).begin().addMiliseconds(-1);
};
Date.prototype.begin = function () {
    return new Date(this.toFormat('MM/dd/yyyy'));
};
Date.prototype.end = function () {
    const date = this;
    return date.addDays(1).begin().addMiliseconds(-1);
};
Date.prototype.addMiliseconds = function (miliseconds) {
    const date = this;
    date.setMilliseconds(date.getMilliseconds() + miliseconds);
    return date;
};
Date.prototype.addHours = function (hours) {
    const date = this;
    date.setHours(date.getHours() + hours);
    return date;
};
Date.prototype.addDays = function (days) {
    const date = this;
    date.setDate(date.getDate() + days);
    return date;
};
Date.prototype.addMonths = function (months) {
    const date = this;
    date.setMonth(date.getMonth() + months);
    return date;
};
Date.prototype.toFormat = function (format) {
    const date = this;
    let result = format;
    result = result.replace('yyyy', date.getFullYear().toString());
    result = result.replace('MM', (date.getMonth() + 1).toString().padStart(2, '0'));
    result = result.replace('dd', date.getDate().toString().padStart(2, '0'));
    result = result.replace('HH', date.getHours().toString().padStart(2, '0'));
    result = result.replace('mm', date.getMinutes().toString().padStart(2, '0'));
    result = result.replace('ss', date.getSeconds().toString().padStart(2, '0'));
    return result;
};

class TrViewdefDirective {
    constructor(template) {
        this.template = template;
    }
}
TrViewdefDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: TrViewdefDirective, deps: [{ token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive });
TrViewdefDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.2.3", type: TrViewdefDirective, selector: "[trViewDef]", ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: TrViewdefDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[trViewDef]',
                }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef }]; } });

class TrCommonModule {
}
TrCommonModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: TrCommonModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
TrCommonModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.3", ngImport: i0, type: TrCommonModule, declarations: [TrViewdefDirective], imports: [CommonModule], exports: [TrViewdefDirective] });
TrCommonModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: TrCommonModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: TrCommonModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [TrViewdefDirective],
                    imports: [CommonModule],
                    exports: [TrViewdefDirective],
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { TrCommonModule, TrViewdefDirective };
//# sourceMappingURL=truongcomp-truong-ui-common.mjs.map
